#include "fkt.h"

#include <fstream>
#include <iostream>

#include <string.h>


#include "HashFunctions/include/HashFunction.h"

#include "set"

double gettime(double** medtime, uint32_t* ft, uint32_t** fts, float* eps, uint32_t* n,uint32_t length, float epss, uint32_t ns, uint32_t b)
{
	bool found=false;
	uint32_t i;
	for(i=0; i<length;i++)
	{
		if(eps[i]==epss && n[i]==ns){
			found =true;
			break;
		}
	}
	if(found)
	{
		for(uint32_t j=0; j<ft[i];j++)
			if(fts[i][j]==b)
				return medtime[i][j];
	}
	
	return 0.0;
}

void medtimetex(char* _ifiles[], char* _ofile, uint32_t _length, uint32_t* _fts, uint32_t _ft)
{
	std::set<uint32_t> sft;
	for(uint32_t i=0;i<_ft;i++)
		sft.insert(_fts[i]);
	std::cout<<"length="<<_length<<"\n";
	//will contain read lines from the inputfile
	char input[55];
	
	//the name of the outputfile.tex
	char onametex[100];
	strcpy(onametex,_ofile);
	strcat(onametex,".tex");
	
	double** medtime = new double*[_length];
	uint32_t* ft = new uint32_t[_length];
	uint32_t** fts = new uint32_t*[_length];
	float* eps = new float[_length];
	uint32_t* n = new uint32_t[_length];


	std::set<uint32_t> set_n;
	std::set<float> set_eps;	
	std::set<uint32_t> set_ft;
	for(uint32_t k=0; k<_length;k++)
	{
		std::fstream ifile(_ifiles[k],std::ios::in);
		if(!ifile.is_open())
		{
			std::cout<<"Couldn't open inputfile\n";
			return;
		}
		
		//read headline from inputfile
		ifile.read(input, 43);
		
		//read the saved number of executet experiments
		uint32_t exp = h2i<uint32_t>(input, 1,8);
		
		//read the saved number of tested functiontypes
		ft[k] = h2i<uint32_t>(input,9,4);
		eps[k] = h2i<float>(input, 37,4)/10000.0;
		n[k]=h2i<uint32_t>(input,13,8);
		
		set_n.insert(n[k]);
		set_eps.insert(eps[k]);
		uint32_t values=exp;

		uint64_t** time= new uint64_t*[ft[k]];
		medtime[k] = new double[ft[k]];
		for(uint32_t i=0;i<ft[k];i++)
			time[i]=new uint64_t[values];
		//will contain the number of each functiontype
		fts[k] = new uint32_t[ft[k]];
		
		//read the results of the first experiment
		for(uint32_t i=0;i<ft[k];i++)
		{
			//read one line from the inputfile
			ifile.read(input, 54);
			
			fts[k][i]=h2i<uint32_t>(input, 9,4);    
			set_ft.insert(fts[k][i]);	
			uint64_t acttime = h2i<uint64_t>(input,13,16);
			
			//store time value
			time[i][0]=acttime;
		}
		


		//read the results of all following experiments
		for(uint32_t i=ft[k]; i<exp*ft[k];i++)
		{
			uint32_t t=i%ft[k];
			uint32_t l=i/ft[k];
			//read one line
			ifile.read(input, 54);
			uint64_t acttime = h2i<uint64_t>(input,13,16);
			
			//update the time value
			time[t][l]=acttime;		
		}
		//finished processing the inputfile
		ifile.close();		
		
		for(uint32_t i=0; i<ft[k]; i++){
			sort(time[i],values);
		}
		
		uint32_t med=values/2;

		for(uint32_t i=0; i<ft[k];i++)
		{	
			uint32_t r = (uint32_t)(time[i][med]%(exp*1000000));
			uint32_t d = (uint32_t)(time[i][med]/(exp*1000000));
			medtime[k][i]=((double) d + ((double)r/(double)(1000000)));
		}
		for(uint32_t i=0; i<ft[k]; i++)
			delete[] time[i];
		delete[] time;
	}
	

	std::fstream ofile(onametex , std::ios::out|std::ios::trunc);
	std::set<uint32_t>::iterator it_n;
	std::set<uint32_t>::iterator it_ft;
	std::set<float>::iterator it_eps;
	for(it_ft=set_ft.begin();it_ft!=set_ft.end();it_ft++)
	{
		if((_ft==0)||(sft.find(*it_ft)!=sft.end()))
		{
			HashFunction* test= HashFunction::create(*it_ft,1000);
			it_n=set_n.begin();
			ofile<<"\n\n\n%Zeittabelle für Funktionstyp:"<<test->getSpecifier()<<"\n";
			ofile<<"\\begin{tabular}[c]{c";
			for(int i=0; i<set_n.size();i++)
				ofile<<"|c";
			ofile<<"}\n";
			do{
				ofile<< " & "<<*it_n;
				it_n++;	
			}while(it_n != set_n.end());
			ofile<<"\n";
			it_eps = set_eps.end();
			do{
				it_eps--;
				ofile<<"\\\\ \\hline\n"<<*it_eps;
				for(it_n = set_n.begin();it_n != set_n.end();it_n++){
					double time = gettime(medtime,ft,fts,eps,n,_length, *it_eps, *it_n, *it_ft);
					if(time != 0)
						ofile<<" & "<<time;
					else
					{
						std::cout<<"eps"<<*it_eps<<" n "<<*it_n<<" ft "<<*it_ft<<"\n";
						ofile<<" & -";
					}
				}
				ofile<<"\n";
			}while(it_eps != set_eps.begin());
			ofile<<"\\end{tabular}\n";
			delete test;
		}
	}
	//clear allocated memory
	for(uint32_t k=0; k<_length;k++)
	{
		delete[] fts[k];	
		delete[] medtime[k];
	}
	delete[] fts;
	delete[] ft;
	delete[] eps;
	delete[] n;
	delete[] medtime;
}



void boxplotchanges(char* _ifile, char* _ofile, int &_index, uint32_t* _fts,uint32_t _ft)
{
	std::set<uint32_t> sft;
	for(uint32_t i=0;i<_ft;i++)
		sft.insert(_fts[i]);
	//will contain read lines from the inputfile
	char input[55];
	
	//the name of the outputfile.dat
	char onamedat[100];
	//the name of the outputfile.gpl
	char onamegpl[100];
	strcpy(onamedat,_ofile);
	strcat(onamedat,".dat");
	strcpy(onamegpl,_ofile);
	strcat(onamegpl,".gpl");
	

	std::fstream ifile(_ifile,std::ios::in);
	if(!ifile.is_open())
	{
		std::cout<<"Couldn't open inputfile\n";
		return;
	}
	
	//read headline from inputfile
	ifile.read(input, 43);
	
	//read the saved number of executet experiments
	uint32_t exp = h2i<uint32_t>(input, 1,8);
	
	//read the saved number of tested functiontypes
	uint32_t ft = h2i<uint32_t>(input,9,4);
	
	uint32_t values = exp;

	//will contain the avg min and max time for each tested functiontype
	uint64_t** time= new uint64_t*[ft];
	for(uint32_t i=0;i<ft;i++)
		time[i]=new uint64_t[values];
	//will contain the number of each functiontype
	uint32_t* fts = new uint32_t[ft];
	
	//read the results of the first experiment
	for(uint32_t i=0;i<ft;i++)
	{
		//read one line from the inputfile
		ifile.read(input, 54);
		
		fts[i]=h2i<uint32_t>(input, 9,4);    
		uint64_t acttime = h2i<uint64_t>(input,37,16);
		
		//store time value
		time[i][0]=acttime;
	}
	
	//read the results of all following experiments
	for(uint32_t i=ft; i<exp*ft;i++)
	{
		uint32_t t=i%ft;
		uint32_t k=i/ft;
		//read one line
		ifile.read(input, 54);
		uint64_t acttime = h2i<uint64_t>(input,37,16);
		
		//update the time value
		time[t][k]=acttime;		
	}
	//finished processing the inputfile
	ifile.close();		
	for(uint32_t i=0; i<ft; i++){
		sort(time[i],values);
	}

	
	//open the output.dat file
	std::fstream ofile(onamedat, std::ios::out|std::ios::app);
	if(!ofile.is_open())
	{	std::cout<<"Couldn't open destination file";
		return;
	}
	uint32_t med=values/2;
	uint32_t quart=values/4;
	uint32_t min=values/40;
	ofile<<"\n\nFunctiontype \"2.5%\" \"25%\" \"50%\" \"75%\" \"97.5%\"\n";
	for(uint32_t i=0; i<ft;i++)
	{
		if((_ft==0)||(sft.find(fts[i])!=sft.end()))
		{
			HashFunction* test= HashFunction::create(fts[i],1000);
				
			ofile<<"\""<<test->getSpecifier()<<"\" "<<i<<" ";
			ofile<<time[i][min]<<" ";
			ofile<<time[i][quart]<<" ";
			ofile<<time[i][med]<<" ";
			ofile<<time[i][values-quart]<<" ";
			ofile<<time[i][values-min] <<"\n";
			
			delete test;
		}
	}
	


	ofile.close();
	
	//open the gpl file
	ofile.open(onamegpl,std::ios::out|std::ios::app);
	ofile<<"reset\n"<<
		"set ylabel \"#Swaps\"\n"<<
		"set terminal svg ##enhanced size 4000 1000 fname \"Times\" fsize 36\n" <<
		"set output \""<<_ofile<<_index<<".svg\"\n" <<
		"set boxwidth .4\n"<<
		"set xrange [-0.5:"<<ft-1<<".5]\n"<<
		"set xtics rotate by -90 font \",8\"\n"<< 
		"plot '"<< onamedat <<"'" 
		<<"using 2:4:3:7:6:xtic(1) index " << _index <<" with candlesticks lt 7 lw 2 notitle whiskerbars ,"
		<<"'' using 2:5:5:5:5 index " << _index << " with candlesticks lt 1 lw 2 notitle"
		;
	ofile.close();
	_index +=1;
	
	//clear allocated memory
	for(uint32_t i=0; i<ft; i++)
		delete[] time[i];
	delete[] time;
	delete[] fts;
}



void boxplottime(char* _ifile, char* _ofile, int &_index, uint32_t* _fts, uint32_t _ft)
{
	std::set<uint32_t> sft;
	for(uint32_t i=0; i<_ft;i++)
	{
		sft.insert(_fts[i]);
	}
	//will contain read lines from the inputfile
	char input[55];
	
	//the name of the outputfile.dat
	char onamedat[100];
	//the name of the outputfile.gpl
	char onamegpl[100];
	strcpy(onamedat,_ofile);
	strcat(onamedat,".dat");
	strcpy(onamegpl,_ofile);
	strcat(onamegpl,".gpl");
	

	std::fstream ifile(_ifile,std::ios::in);
	if(!ifile.is_open())
	{
		std::cout<<"Couldn't open inputfile\n";
		return;
	}
	
	//read headline from inputfile
	ifile.read(input, 43);
	
	//read the saved number of executet experiments
	uint32_t exp = h2i<uint32_t>(input, 1,8);
	
	//read the saved number of tested functiontypes
	uint32_t ft = h2i<uint32_t>(input,9,4);
	
	uint32_t values = exp;

	//will contain the avg min and max time for each tested functiontype
	uint64_t** time= new uint64_t*[ft];
	for(uint32_t i=0;i<ft;i++)
		time[i]=new uint64_t[values];
	//will contain the number of each functiontype
	uint32_t* fts = new uint32_t[ft];
	
	//read the results of the first experiment
	for(uint32_t i=0;i<ft;i++)
	{
		//read one line from the inputfile
		ifile.read(input, 54);
		
		fts[i]=h2i<uint32_t>(input, 9,4);    
		uint64_t acttime = h2i<uint64_t>(input,13,16);
		
		//store time value
		time[i][0]=acttime;
	}
	
	//read the results of all following experiments
	for(uint32_t i=ft; i<exp*ft;i++)
	{
		uint32_t t=i%ft;
		uint32_t k=i/ft;
		//read one line
		ifile.read(input, 54);
		uint64_t acttime = h2i<uint64_t>(input,13,16);
		
		//update the time value
		time[t][k]=acttime;		
	}
	//finished processing the inputfile
	ifile.close();		
	for(uint32_t i=0; i<ft; i++){
		sort(time[i],values);
	}

	
	//open the output.dat file
	std::fstream ofile(onamedat, std::ios::out|std::ios::app);
	if(!ofile.is_open())
	{	std::cout<<"Couldn't open destination file";
		return;
	}
	uint32_t med=values/2;
	uint32_t quart=values/4;
	uint32_t min=values/40;
	ofile<<"\n\nFunctiontype \"2.5%\" \"25%\" \"50%\" \"75%\" \"97.5%\"\n";
	for(uint32_t i=0; i<ft;i++)
	{
		if((_ft==0)||(sft.find(fts[i])!=sft.end()))
		{
			HashFunction* test= HashFunction::create(fts[i],1000);
			
			uint32_t r1 = (uint32_t)(time[i][min]%(exp*1000000));
			uint32_t d1 = (uint32_t)(time[i][min]/(exp*1000000));
			uint32_t r2 = (uint32_t)(time[i][quart]%(exp*1000000));
			uint32_t d2 = (uint32_t)(time[i][quart]/(exp*1000000));
			uint32_t r3 = (uint32_t)(time[i][med]%(exp*1000000));
			uint32_t d3 = (uint32_t)(time[i][med]/(exp*1000000));
			uint32_t r4 = (uint32_t)(time[i][values-quart]%(exp*1000000));
			uint32_t d4 = (uint32_t)(time[i][values-quart]/(exp*1000000));
			uint32_t r5 = (uint32_t)(time[i][values-min]%(exp*1000000));
			uint32_t d5 = (uint32_t)(time[i][values-min]/(exp*1000000));

			ofile<<"\""<<test->getSpecifier()<<"\" "<<i<<" ";
			ofile<<((double) d1 + ((double)r1/(double)(1000000)))<<" ";
			ofile<<((double) d2 + ((double)r2/(double)(1000000)))<<" ";
			ofile<<((double) d3 + ((double)r3/(double)(1000000)))<<" ";
			ofile<<((double) d4 + ((double)r4/(double)(1000000)))<<" ";
			ofile<< ((double) d5 + ((double)r5/(double)(1000000)))<<"\n";
			
			delete test;
		}
	}
	
	ofile<<"\n\n";
	for(uint32_t i=0; i<ft;i++){
		if((_ft==0)||(sft.find(fts[i])!=sft.end()))
		{
			for(uint32_t j=0; j<min;j++){
				uint32_t r = (uint32_t)(time[i][j]%(exp*1000000));
				uint32_t d = (uint32_t)(time[i][j]/(exp*1000000));
			
				ofile<<i<<" "<< ((double) d + ((double)r/(double)(1000000)))<<"\n";
			}
			for(uint32_t j=values-1; j>(values-min);j--){
				uint32_t r = (uint32_t)(time[i][j]%(exp*1000000));
				uint32_t d = (uint32_t)(time[i][j]/(exp*1000000));
			
				ofile<<i<<" "<< ((double) d + ((double)r/(double)(1000000)))<<"\n";
			}
		}
	}
	ofile.close();
	
	//open the gpl file
	ofile.open(onamegpl,std::ios::out|std::ios::app);
	ofile<<"reset\n"<<
		"set ylabel \"t/ms\"\n"<<
		"set terminal svg ##enhanced size 4000 1000 fname \"Times\" fsize 36\n" <<
		"set output \""<<_ofile<<_index<<".svg\"\n" <<
		"set boxwidth .4\n"<<
		"set xrange [-0.5:"<<ft-1<<".5]\n"<<
		"set xtics rotate by -90 font \",8\"\n"<< 
		"plot '"<< onamedat <<"'" 
		<<"using 2:4:3:7:6:xtic(1) index " << _index <<" with candlesticks lt 7 lw 2 notitle whiskerbars ,"
		<<"'' using 2:5:5:5:5 index " << _index << " with candlesticks lt 1 lw 2 notitle ,"
		<<"'' using 1:2 index "<< _index+1<<" notitle";
	ofile.close();
	_index +=2;
	
	//clear allocated memory
	for(uint32_t i=0; i<ft; i++)
		delete[] time[i];
	delete[] time;
	delete[] fts;
}

void time(char* _ifile, char* _ofile, int &_index, uint32_t* _fts, uint32_t _ft)
{
	std::set<uint32_t> sft;
	for(uint32_t i=0; i<_ft;i++)
		sft.insert(_fts[i]);
	//will contain read lines from the inputfile
	char input[55];
	
	//the name of the outputfile.dat
	char onamedat[100];
	//the name of the outputfile.gpl
	char onamegpl[100];
	strcpy(onamedat,_ofile);
	strcat(onamedat,".dat");
	strcpy(onamegpl,_ofile);
	strcat(onamegpl,".gpl");
	

	std::fstream ifile(_ifile,std::ios::in);
	if(!ifile.is_open())
	{
		std::cout<<"Couldn't open inputfile\n";
		return;
	}
	
	//read headline from inputfile
	ifile.read(input, 43);
	
	//read the saved number of executet experiments
	uint32_t exp = h2i<uint32_t>(input, 1,8);
	
	//read the saved number of tested functiontypes
	uint32_t ft = h2i<uint32_t>(input,9,4);

	//will contain the avg min and max time for each tested functiontype
	uint64_t* avgtime= new uint64_t[ft];
	uint64_t* maxtime= new uint64_t[ft];
	uint64_t* mintime= new uint64_t[ft];

	//will contain the number of each functiontype
	uint32_t* fts = new uint32_t[ft];
	
	//read the results of the first experiment
	for(uint32_t i=0;i<ft;i++)
	{
		//read one line from the inputfile
		ifile.read(input, 54);
		
		fts[i]=h2i<uint32_t>(input, 9,4);    
		uint64_t time = h2i<uint64_t>(input,13,16);
		
		//initialize avg min and max time
		avgtime[i]=time;
		maxtime[i]=time;
		mintime[i]=time;
	}
	
	//read the results of all following experiments
	for(uint32_t i=ft; i<exp*ft;i++)
	{
		uint32_t t=i%ft;
		//read one line
		ifile.read(input, 54);
		uint64_t time = h2i<uint64_t>(input,13,16);
		
		//update the time values
		avgtime[t]+=time;
		if(time >maxtime[t])
			maxtime[t]=time;
		if(time< mintime[t])
			mintime[t]=time;	
	}
	//finished processing the inputfile
	ifile.close();
	
	//open the output.dat file
	std::fstream ofile(onamedat, std::ios::out|std::ios::app);
	if(!ofile.is_open())
	{	std::cout<<"Couldn't open destination file";
		return;
	}
	ofile<<"\n\nFunctiontype \"Average Time\" \"Max Time\" \"Min Time\"\n";
	for(uint32_t i=0; i<ft;i++)
	{
		if((_ft==0)||(sft.find(fts[i])!=sft.end()))
		{
			HashFunction* test= HashFunction::create(fts[i],1000);
			
			uint32_t resa = (uint32_t)(avgtime[i]%(exp*1000000));
			uint32_t da = (uint32_t) (avgtime[i]/(exp*1000000));
			
			uint32_t resma = (uint32_t)(maxtime[i]%(1000000));
			uint32_t dma = (uint32_t) (maxtime[i]/(1000000));


			uint32_t resmi = (uint32_t)(mintime[i]%(exp*1000000));
			uint32_t dmi = (uint32_t) (mintime[i]/(exp*1000000));


			ofile<<"\""<<test->getSpecifier()<<"\" "<<((double) da + ((double)resa/(double)(exp*1000000)))<<" "
			<< ((double) dma + ((double)resma/(double)(1000000)))<<" "
			<< ((double) dmi + ((double)resmi/(double)(1000000)))<<"\n";
			delete test;
		}
	}
	ofile.close();
	
	//open the gpl file
	ofile.open(onamegpl,std::ios::out|std::ios::app);
	ofile<<"reset\n"<<
		"set ylabel \"t/ms\"\n"<<
		"set terminal svg ##enhanced size 4000 1000 fname \"Times\" fsize 36\n" <<
		"set output \""<<_ofile<<_index<<".svg\"\n" <<
		"set auto y\n"<<
		"set style data histogram\n"<<
		"set style histogram cluster gap 1\n"<<
		"set style fill solid border -1\n"<<
		"set boxwidth 1.0\n"<<
		"set xtics rotate by -90\n"<<
		"plot '"<< onamedat <<"' using 2:xtic(1) index " << _index <<" ti col, '' using 3 index " << _index << " ti col, '' using 4 index "<< _index<<" ti col";
	ofile.close();
	_index++;
	delete[] avgtime;
	delete[] maxtime;
	delete[] mintime;
	delete[] fts;
	
}

void stash(char* _ifile, char* _ofile, int _maxh, uint32_t* _fts, uint32_t _ft)
{
	std::set<uint32_t> sft;
	for(uint32_t i=0; i<_ft; i++)
		sft.insert(_fts[i]);
	char onametex[100];
	strcpy(onametex,_ofile);
	strcat(onametex,".tex");

	char input[55];
	std::fstream ifile(_ifile,std::ios::in);
	if(!ifile.is_open())
	{
		std::cout<<"Couldn't open inputfile\n";
		return;
	}
	ifile.read(input, 43);
	uint32_t exp = h2i<uint32_t>(input, 1,8);
	uint32_t ft = h2i<uint32_t>(input,9,4);
	uint32_t cnt = h2i<uint32_t>(input, 13,8);
	float epsilon = h2i<float>(input, 37,4)/10000.0;
	uint32_t* * stashs = new uint32_t*[ft];
	for(uint32_t i=0;i<ft;i++)
		stashs[i]=new uint32_t[_maxh+1];

	uint32_t* fts = new uint32_t[ft];
	
	for(uint32_t i=0;i<ft;i++)
	{
		ifile.read(input, 54);
		fts[i]=h2i<uint32_t>(input, 9,4);
		uint32_t stash= h2i<uint32_t>(input,29,8);
		for(int j=0;j<11;j++)
			stashs[i][j]=0;
		if(stash<_maxh)	
			stashs[i][stash]++;
		else
			stashs[i][_maxh]++;
	}

	for(uint32_t i=ft; i<exp*ft;i++)
	{
		uint32_t t=i%ft;
		ifile.read(input, 54);
		uint32_t stash= h2i<uint32_t>(input,29,8);
		if(stash<_maxh)
			stashs[t][stash]++;
		else
			stashs[t][_maxh]++;
	}
	
	ifile.close();
	std::fstream ofile(onametex , std::ios::out|std::ios::trunc);
	if(!ofile.is_open())
	{	
		std::cout<<"Couldn't open destination file";
		return;
	}
	
	ofile<<"\\begin{tabular}[c]{c|c|c||c";
	for(uint32_t i=0; i<=_maxh;i++)
		ofile<<"|c";
	ofile<<"}\n \\hline \\hline";
	
	ofile<<" Functiontype & Number of Keys & $\\varepsilon$ & Experiments";
	for(uint32_t i=0; i<=_maxh;i++)
		ofile<<"& Stash"<< i;
	for(uint32_t i=0; i<ft;i++)
	{
	    	if((_ft==0)||(sft.find(fts[i])!=sft.end()))
	    	{
			ofile<<"\\\\\n";
			HashFunction* test= HashFunction::create(fts[i],1000);
			ofile<<test->getSpecifier()<<" & "<< cnt << " & "<<epsilon <<" & "<< exp ;
		    	for(int j=0;j<=_maxh;j++)
			    	ofile<<" & "<<stashs[i][j];
		    
		    	delete test;
		}
	}
	ofile<<"\n\\end{tabular}";
	ofile.close();
}

void createHeadExperiments(char* _ifile, char* _ofile)
{
	char onamedat[100];
	strcpy(onamedat,_ofile);
	strcat(onamedat,".dat");

	std::fstream ifile(_ifile,std::ios::in);
	char input[45];
	if(!ifile.is_open())
	{
		std::cout<<"Couldn't open inputfile\n";
		return ;
	}
	ifile.read(input,43);
	ifile.close();
	
	std::fstream ofile(onamedat, std::ios::out|std::ios::app);
	if(!ofile.is_open())
	{	std::cout<<"Couldn't open destination file";
		return ;
	}
	
	uint32_t exp = h2i<uint32_t>(input, 1,8);
	float epsilon = (float)(h2i<uint32_t>(input, 37,4))/10000.0;
	uint32_t cnt = h2i<uint32_t>(input,13,8);
	uint32_t maxstash = h2i<uint32_t>(input,21,8);
	uint32_t maxkey = h2i<uint32_t>(input,29,8);
	uint32_t looptype = h2i<uint32_t>(input, 41,1);
	ofile<<"\"Experiments\" \"Keys\" \"max Stash\" \"max Key\" \"epsilon\" \"Loop\"\n";
	ofile<<exp<<" "<< cnt <<" "<< maxstash <<" "<< maxkey <<" "<< epsilon <<" "<< looptype<<"\n";
	ofile.close();
  
}

#include <set>
void functiontesttable(char* _ifiles[], char* _ofile, int _listlength,uint32_t* _fts, uint32_t _ft)
{
	std::set<uint32_t> sft;
	for(uint32_t i=0; i<_ft;i++)
		sft.insert(_fts[i]);
	char** identifier;
	char input[30];
	std::set<uint32_t> fts;
	identifier = new char* [_listlength];
	std::fstream ifile;
	double ** times = new double* [_listlength];
	for(int i=0; i< _listlength; i++)
	{
		times[i] = new double[20];
		uint64_t sum_time[20];
		for(uint32_t j=0;j<20;j++)
		{
			sum_time[j]=0;
			times[i][j]=0;
		}
		ifile.open(_ifiles[i], std::ios::in);
		ifile.read(input,30);
		if(input[0]!='?')
			break;
		uint32_t idl = h2i<uint32_t>(input, 21,8);
		uint32_t testcnt = h2i<uint32_t>(input,1,8);
		uint32_t fkttypes = h2i<uint32_t>(input,9,4);
		uint32_t keys = h2i<uint32_t>(input, 13,8);
		identifier[i]= new char[idl+1];
		ifile.read(identifier[i],idl+1);
		identifier[i][idl]='\0';
		for(uint32_t j=0; j<(fkttypes*testcnt);j++)
		{
			ifile.read(input, 30);
			uint32_t ft=h2i<uint32_t>(input,9,4);
			fts.insert(ft);
			uint64_t time = h2i<uint64_t>(input, 13,16);
			sum_time[ft]+=time;
		}
		for(int t=0;t<20;t++)
		{
			uint32_t x = testcnt*keys;
			uint64_t res = (uint32_t)(sum_time[t]%(x));
			uint64_t d = (uint32_t) (sum_time[t]/(x));
			times[i][t]= (double)(d)+(double)(res)/(double)(x);
		}
		ifile.close();
	}
	std::fstream ofile(_ofile, std::ios::out|std::ios::trunc);
	ofile<<"\\begin{tabular}[c]{c";
	for(int i=0; i< _listlength;i++)
		ofile<<"|c";
	ofile<<"}\nFunctiontype";
	for(int i=0;i<_listlength; i++)
		ofile<<" & "<<identifier[i];
	ofile<<" \\hline" ;
	std::set<uint32_t>::iterator it;
	for(it=fts.begin(); it!=fts.end();it++)
	{
		if((_ft == 0)||(sft.find(*it)!=sft.end()))
		{
	    		HashFunction* test= HashFunction::create( *it , 1000);
	    		ofile<<"\\\\\n \\hline "<<test->getSpecifier();
	    		delete test;
	    		for(int i=0; i<_listlength;i++)
	    		{
				ofile<<" & " <<times[i][*it];
	    		}
		}
	}
	ofile<<"\\end{tabular}";
	ofile.close();
}

void help()
{
  std::cout <<"Usage: \n"
	    <<"Funktionname [Options]\n"
	    <<"Possible Options:\n"
	    <<"-o <name>            - defines the name of the outputfile. Different outputfiles may be created.\n"
	    <<"                       <name>.gpl, name.dat and <name>.tex for the different Options.\n"  
	    <<"-i <name> [<name>]   - defines the inputfile. May be the result of experiments or functiontests\n"
	    <<"                       all inputed files have to be the same format as the first (experiment or functiontest)\n"
	    <<"                       Commands with multifilesupport are Marked with an astrisk (*)\n"
	    <<"-c <value> [<value>] - defines the Tables that are going to be created possible values for experiment results:\n"
	    <<"                         t - creates a barchart that shows the min/max/avg execution time\n"
	    <<"                         s - creates a table showing the used stashheights\n"
	    <<"                         b - creates a boxplot showing the time values\n"
	    <<"                         c - creates a boxplot showing the number of changes\n"
	    <<"                         a - * creates a table for each functiontype containing the medium execution time\n"
	    <<"                       possible Values for Functiontest input:\n"
	    <<"                         t - * creates a table with all avg execution times for the specified functiontypes\n";
}
