#include <fstream>
#include <iostream>
#include <stdint.h>

#include "fkt.h"

uint32_t n2i(char* in)
{
	uint32_t res=0;
	int i=0;
	while(in[i]!=0)
	{
		res*=10;
		res+=in[i]-'0';
		i++;
	}
	return res;
}

int main(int argc, char* argv[])
{
	char* inames[1000];
	int numinput=1;
	inames[0] = const_cast<char*>("experiment.res");
	char* oname= const_cast<char*>("res");
	char commands[40];
	int comm = 0;
	uint32_t fts[100];
	uint32_t ft=0;
	bool experiments=true;
	for(int i=1; i<argc;i++)
	{
	  switch(argv[i][1])
	  {
	    case 'i':
	      numinput=0;
	      i++;
	      for(i;i<argc && argv[i][0]!='-' ;i++)
	      {
		  if(numinput<1000)
		  {
		    inames[numinput] = argv[i];
		    numinput++;
		  }
		  
	      }
	      i--;
	      break;
	    case 'c':
	      comm=0;
	      i++;
	      for(i;i<argc && argv[i][0]!='-' ;i++)
	      {
		  if(comm<40)
		  {
		    commands[comm] = argv[i][0];
		    comm++;
		  }
		  
	      }
	      i--;
	      break;
	    case 'f':
	      ft=0;
	      i++;
	      for(i;i<argc && argv[i][0]!='-' ;i++)
	      {
		  if(ft<100)
		  {
		    fts[ft] = n2i( argv[i] );
		    ft++;
		  }
		  
	      }
	      i--;
	      break;

	    case 'o':
	      if(++i<argc)
		  oname=argv[i];
	      break;
	    case 'h':
	      help();
	      return 0;
	    default:
	      std::cout<<"Unknown command: "<<argv[i]<<"\n";
	      help();
	      return 0;
	  }
	}
	if(numinput==0)
	{
	  std::cout<<"Needs parameters for -i, call with -h for help";
	
	  return 0;
	}else
	{
	  char buf[10];
	  std::fstream file(inames[0]);
	  if(!file.is_open())
	  {
	    std::cout<<"Couldn't open input file";
	    return 0;
	  }
	  file.read(buf,10);
	
	  if(buf[0]=='?')
	    experiments=false;
	}
	if(experiments)
	{
		createHeadExperiments(inames[0],oname);
		int k=1;
		for(int i=0; i<comm; i++)
		{
		  switch(commands[i])
		  {
	    		case 'c':
			boxplotchanges(inames[0],oname,k,fts,ft);
			break;
			case 'b':
			boxplottime(inames[0],oname,k,fts,ft);
			break;
			case 't':
	     		time(inames[0],oname,k,fts,ft); 
	      		break;
	    		case 's':
			stash(inames[0],oname,10,fts,ft);
			break;
			case 'a':
			medtimetex(inames, oname, numinput, fts, ft);
			break;
	    		default:
	      		break;
	  	  }
		}
	}
	else
	{
		for(int i=0; i<comm; i++)
		{
		  switch(commands[i])
		  {
			  case 't':
				  functiontesttable(inames,oname, numinput,fts,ft);
				  break;
			default: break;
		  }
		}
	}
	return 0;
}	
