#include "2Universal.h"
#include "rand_singleton.h"


sizetype TwoUniversal::h1 (keytype _key)
{
	// calculates (a*x)>>(lin-lout)
	sizetype res = p_a1 * _key;		
	return( res>>p_shift );
}
sizetype TwoUniversal::h2 (keytype _key)
{
	// calculate (a*x)>>(lin-lout)
	sizetype res = p_a2 * _key;
	return ( res>>p_shift );
}

TwoUniversal::TwoUniversal(sizetype _hashsize)
{
	//calculate the lout value
	uint32_t lout = 0;
	// a power of two is expected for _hashsize
	// calculate the logarithm to base 2 of _hashsize
	-- _hashsize;
	for(lout=0; _hashsize!=0;lout++)
		_hashsize/=2;
	// inputsize of 32 bit integer is expected
	p_shift = 32-lout;
	
	RandomGenerator* gen = RandomGenerator::get();
	gen->range(0, 0xFFFFFFFF);
	
	//choose the 2 required parameters
	p_a1=gen->rand();

	p_a2=gen->rand();
}
