#include "FullyRandom.h"
#include "rand_singleton.h"
RandomHashFunction::RandomHashFunction(sizetype _hashsize):p_m(_hashsize-1){}
sizetype RandomHashFunction::h1(keytype _key)
{
    KeyFunction x(_key);
    std::set<KeyFunction>::iterator it = p_set.find(x);
    /// if no hashvalues were chosen for this key
    if(it == p_set.end())
    {
        RandomGenerator* rg= RandomGenerator::get();
        rg->range(0,p_m);
        /// choose hashvalues for both hashfunctions.
        x.h1=(sizetype)(rg->rand());
        x.h2=(sizetype)(rg->rand());
        // insert this key-hashvalue-triple into the set
        p_set.insert(x);
        return x.h1;
    }else
    {
        return (*it).h1;
    }
}
sizetype RandomHashFunction::h2(keytype _key)
{
    KeyFunction x(_key);
    std::set<KeyFunction>::iterator it = p_set.find(x);
    /// if no hashvalues were chosen for this key
    if(it == p_set.end())
    {
        RandomGenerator* rg= RandomGenerator::get();
        rg->range(0,p_m);
        /// choose hashvalues for both hashfunctions.
        x.h1=(sizetype)(rg->rand());
        x.h2=(sizetype)(rg->rand());
        /// insert this key-hashvalue-triple into the set.
        p_set.insert(x);
        return x.h2;
    }else
    {
        return (*it).h2;
    }
}   
