#include "HashFunction.h"
#include "CW5Universal.h"
#include "SimpleHashing.h"
#include "TB5Universal.h"
#include "TB5U32t8.h"
#include "UI5Universal.h"
#include "CWkUniversal.h"
#include "2Universal.h"
#include "DAK1.h"
#include "DAK2.h"
#include "DAC1.h"
#include "FullyRandom.h"
HashFunction * HashFunction::create(uint32_t _functiontype,sizetype _hashsize, sizetype _stashsize, keytype _universesize) 
{
	switch(_functiontype)
	{
        case 9:
            return new RandomHashFunction(_hashsize);
            break;
		case 8:
			return new TB5U32t8(_hashsize);
			break;
		case 7:
			return new DAC1(_hashsize, _universesize);
			break;
		case 6:
			return new DAK2(_hashsize, _universesize);
			break;
		case 5: 
			return new DAK1(_hashsize, _universesize);
			break;
		case 4: 
			return new TwoUniversal(_hashsize);
			break;
		case 3:
			return new UI5Universal(_hashsize);
			break;
		case 2:
			return new TB5Universal(_hashsize);
			break;
		case 1:
			return new CW5Universal(_hashsize);
			break;
		case 0:

			return new SimpleHashFunction(_hashsize);
			break;
		default: break;
	}

	// Hack to set the degree of independence in a uniform way
	// See CWkUniversal.cpp
	if((_functiontype/1000)==1)
		return new CWkUniversal(_hashsize, _functiontype%1000);

	return new SimpleHashFunction(_hashsize);
}
