#include "SimpleHashing.h"
#include "rand_singleton.h"


sizetype SimpleHashFunction::h1 (keytype _key)
{	
	return (sizetype)(CWTrick(_key,a1,b1)%m);
}
sizetype SimpleHashFunction::h2 (keytype _key)
{
	return (sizetype)(CWTrick(_key,a2,b2)%m);
}

SimpleHashFunction::SimpleHashFunction(sizetype _hashsize)
{
	//the used mersenne prime. a mersenne prime is needed for the use of the CW-Trick.
	//2^61-1
	p=((universetype)(1)<<61 )-1;
	//store the range of the hashfunctions
	m=_hashsize;
	RandomGenerator* gen = RandomGenerator::get();
	gen->range(0, p-1);
	
	//intialize the parameters for both hashfunctions.
	a1=gen->rand();
	b1=gen->rand();
	a2=gen->rand();
	b2=gen->rand();
}

inline universetype SimpleHashFunction::CWTrick(keytype _x, universetype _a, universetype _b){
	  universetype a0,a1,c0,c1,c,h;
	  //multiply x with the lower 32bit of a
	  a0 = (_a&0xFFFFFFFF)*_x;
	  //multiply x with the upper 32 bit of a
	  a1 = (_a>>32)*_x;
	  // calculate the lower 64 bit of the result
	  c0 = a0 + (a1 << 32);
	  //calculate bist 33..72 of the result
	  c1 = (a0>>32)+a1;
	  //apply the cw-trick to calculate a*x+b mod p for a mersenne prime p.
	  c=  (c0 & p)+(c1>>29)+_b ;
	  return (c&p)+(c>>61);
}
