#include "TB5Universal.h"
#include "rand_singleton.h"

TB5Universal::~TB5Universal()
{
  //free the space allocated for each table
  delete[] p_t01;
  p_t01 = 0;
  delete[] p_t11;
  p_t11=0;
  delete[] p_t21;
  p_t21=0;

  
  delete[] p_t02;
  p_t02 = 0;
  delete[] p_t12;
  p_t12=0;
  delete[] p_t22;
  p_t22=0;
}
TB5Universal::TB5Universal(sizetype _hashsize)
{
  // initialize all tables
  p_t01=new sizetype[0x10000];
  p_t11=new sizetype[0x10000];
  p_t21=new sizetype[0x10000];
  
  p_t02=new sizetype[0x10000];
  p_t12=new sizetype[0x10000];
  p_t22=new sizetype[0x10000];
  
  RandomGenerator* gen = RandomGenerator::get();
  gen->range(0, 0xFFFFFFFF);
  
  
  for(unsigned int i=0; i<0x10000;i++)
  {
    // fill the tables with random values
    p_t01[i]=gen->rand32();
    p_t11[i]=gen->rand32();
    p_t21[i]=gen->rand32();
    
    p_t02[i]=gen->rand32();
    p_t12[i]=gen->rand32();
    p_t22[i]=gen->rand32();
  }
  //store hashsize
  p_m = _hashsize;
}


sizetype TB5Universal::h1 (keytype _key)
{
  // split the key in lower and upper 16 bit
  uint32_t x0=_key&(0xFFFF);
  uint32_t x1=_key>>16;
  //calculate the position in the 3rd table
  uint32_t x2=x0+x1;
  x2=compressShort32(x2);
  // read the corresponding values from the hashtables
  // different values get connected by xor
  sizetype res = p_t01[x0]^p_t11[x1]^p_t21[x2];
  return (res % p_m);
}
sizetype TB5Universal::h2 (keytype _key)
{
  //split the key in lower and upper 16 bit
  uint32_t x0=_key&(0xFFFF);
  uint32_t x1=_key>>16;
  //callculate the position in the 3rd hashtable
  uint32_t x2=x0+x1;
  x2=compressShort32(x2);
  // read the corresponding values from the hashtables
  // different values get connected by xor
  sizetype res =p_t02[x0]^p_t12[x1]^p_t22[x2];
  return (res % p_m);
}
