#include "UI5Universal.h"
#include "rand_singleton.h"

sizetype UI5Universal::h1 (keytype _key)
{
	//calculate a*x^4+b*x^3+c*x^2+d*x+e
	universetype res = 
		    basic(_key,
		      basic(_key,
			basic(_key,
			  basic(_key,p_a1,p_b1)
			  ,p_c1)
			,p_d1)
		      ,p_e1);
		    
	
	res %= p_m;
	return (sizetype) res;
}

sizetype UI5Universal::h2 (keytype _key)
{
	//calculate a*x^4+b*x^3+c*x^2+d*x+e
	universetype res = 
		    basic(_key,
		      basic(_key,
				basic(_key,
					basic(_key,p_a2,p_b2)
					,p_c2)
				,p_d2)
		      ,p_e2);
	
	res %= p_m;
	return (sizetype) res;
}

inline universetype UI5Universal::basic(keytype _x, universetype _a, universetype _b){
	  universetype res = (_a * _x + _b)%p_prime;
	  return( res );
}

UI5Universal::UI5Universal(sizetype _hashsize)
{
	//define the prime
  	p_prime=((universetype)(1)<< 32)-5;
	//save the hashsize
	p_m=_hashsize;
	
	RandomGenerator* gen= RandomGenerator::get();	
	gen->range(0, p_prime-1);

	//choose the used parameters
	p_a1=gen->rand();
	p_b1=gen->rand();
	p_c1=gen->rand();
	p_d1=gen->rand();
	p_e1=gen->rand();
	p_a2=gen->rand();
	p_b2=gen->rand();
	p_c2=gen->rand();
	p_d2=gen->rand();
	p_e2=gen->rand();
}
