#include"rand_singleton.h"

RandomGenerator* RandomGenerator::gen = NULL;

RandomGenerator::RandomGenerator()
{
	//initializes the randomgenerator with a range of full 64 bit
	p_min = 0;
	p_max = 0xFFFFFFFFFFFFFFFF;
	boost::uniform_int<uint64_t> rng(p_min,p_max);

	// take the current time as seed
	// this generator stays the same unless you explecitly set the seed
	p_generator.seed(time(0));

	// creates the corresponding random function	
	next = new boost::variate_generator<boost::mt19937_64&, boost::uniform_int<uint64_t> >(p_generator, rng);
}
RandomGenerator::~RandomGenerator()
{
	//release the randomfunction.
	if(next!=NULL)
		delete next;
	next=NULL;
}
void RandomGenerator::range(uint64_t _min, uint64_t _max)
{
	//set the new range of the randomfunction
	if(p_min==_min && p_max==_max)
        return;
    p_min = _min;
	p_max = _max;
	if(next != NULL)
		delete next;
	//create a new range
	boost::uniform_int<uint64_t> rng(_min,_max);
	//create the new randomfunction
	next= new boost::variate_generator<boost::mt19937_64&, boost::uniform_int<uint64_t> >(p_generator,rng);
}
