/// Cuckoo Hashing.cpp : Defines the entrypoint for the console aplication.


#include <iostream>
#include "Help.h"
#include "rand_singleton.h"

int main(int argc, char* argv[])
{
	sizetype 	stashsize=400;
	sizetype	hashtablesize=100000;
	keytype 	universesize =0x8FFFFFFF;
	int 		looptype=0;
	uint32_t 	functiontype[50];
	uint32_t 	numfunction=3;
	uint32_t 	cnt=100;
	uint32_t 	epsilon = 1000;
	bool 		experiments =false, ftest = false;
	char*		id;
	char* 		outfile = const_cast<char*>("experiment.res");
      
	functiontype[0]=0;functiontype[1]=1;functiontype[2]=2;
	///Processing the inputparameters
	for(unsigned int i=1;i<argc; i++)
	{
		if(argv[i][0]!='-')
			std::cout<<"Unhandled Input: "<<argv[i]<<"\n"<<"Call with \"-h\" for more information\n";
		switch(argv[i][1])
		{
			case 's':
				if(++i<argc)
				    stashsize=a2i<sizetype>(argv[i]);
				break;
			case 't':
				if(++i<argc)
				    hashtablesize=a2i<sizetype>(argv[i]);
				break;
			case 'l':
				if(++i<argc)
				    looptype = a2i<int>(argv[i]);
				break;
			case 'f':
				numfunction=0;
				i++;
				for(i;i<argc && argv[i][0]!='-';i++)
				{
				    functiontype[numfunction] = a2i<int>(argv[i]);
				    numfunction++;
				}
				i--;
				break;
			case 'u':
				if(++i<argc)
				      universesize = a2i<keytype>(argv[i]);
				break;
			case 'x':
				experiments = true;
				break;
			case 'y':
				ftest = true;
				break;
			case 'e':
				if(++i<argc)
				    epsilon = a2i<uint32_t>(argv[i]); 	
				break;
			case 'i':
				if(++i<argc)
				    cnt = a2i<uint32_t>(argv[i]);
				break;
			case 'o':
				if(++i<argc)
				    outfile = argv[i];
				break;
			case 'd':
				if(++i<argc)
					id = argv[i];
				break;
			case 'h':
				help(); 	
				return 0;
				break;
			default:
				std::cout<<"Unhandled Input: "<<argv[i]<<"\n"<<"Call with  \"-h\" for more information\n";
				return 0;
				break;
		}
	}

	if(experiments)
	{
	    experiment(hashtablesize, stashsize, universesize, functiontype, numfunction, epsilon, looptype, cnt,outfile);
	
	    if(ftest)
	    {
		std::cout << "Can't execute experiments and functiontest in one run. Only experiments were executed";
	    }
	}
	else
	{
	    if(ftest)
		functiontest(functiontype,numfunction,hashtablesize, cnt,outfile);
	    else
		singletest(hashtablesize, stashsize, universesize, epsilon, looptype, functiontype[0]);
	}
	RandomGenerator::free();	
	return 0;
}
